
import numpy as np 
from sys import path
path.append(r"C:/Users/Bruker/Documents/CASADIPython/casadi-windows-py38-v3.5.5-64bit")
from casadi import *
import casadi as ca
from tabulate import tabulate
from texttable import Texttable
import latextable
from decimal import Decimal
import xlsxwriter

ep = 1e-8 #perturb value
import FiniteDiffJud


def Jud(valve1, valve2, disturbance1, disturbance2,eps):
    Jud = np.zeros((2,2))
    nom, deltanom, deltanom1 = FiniteDiffJud.OptimizerDiffud(1,1,0,0)
    for i in range(2):
        for j in range(2):
                if i == 0 and j == 0:
                    f1, h1, k1 =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance1, eps,eps)
                    f2, h,k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance1, eps,0)
                    f3, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance1, 0,eps)
                    f4, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance1, -eps,0)
                    f5, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance1, 0,-eps)
                    f6, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance1, -eps,-eps)
                    Jud[i][j] = (f1 - f2 - f3 + 2*nom - f4 - f5 + f6)/(2*h1*k1)
                if i == 0 and j == 1:
                    f1, h1, k1 =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance2, eps,eps)
                    f2, h,k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance2, eps,0)
                    f3, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance2, 0,eps)
                    f4, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance2, -eps,0)
                    f5, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance2, 0,-eps)
                    f6, h, k =  FiniteDiffJud.OptimizerDiffud(valve1,disturbance2, -eps,-eps)
                    Jud[i][j] = (f1 - f2 - f3 + 2*nom - f4 - f5 + f6)/(2*h1*k1)
                if i == 1 and j == 0:
                    f1, h1, k1 =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance1, eps,eps)
                    f2, h,k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance1, eps,0)
                    f3, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance1, 0,eps)
                    f4, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance1, -eps,0)
                    f5, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance1, 0,-eps)
                    f6, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance1, -eps,-eps)
                    Jud[i][j] = (f1 - f2 - f3 + 2*nom - f4 - f5 + f6)/(2*h1*k1)
                
                if i == 1 and j == 1:
                    f1, h1, k1 =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance2, eps,eps)
                    f2, h,k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance2, eps,0)
                    f3, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance2, 0,eps)
                    f4, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance2, -eps,0)
                    f5, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance2, 0,-eps)
                    f6, h, k =  FiniteDiffJud.OptimizerDiffud(valve2,disturbance2, -eps,-eps)
                    Jud[i][j] = (f1 - f2 - f3 + 2*nom - f4 - f5 + f6)/(2*h1*k1)
                 #Different so will use 
            #f''(x,y) = ( f(x+h,y+k) - f(x+h,y) - f(x,y+k) + 2f(x,y) - f(x-h,y) - f(x,y-k) 
            #+ f(x-h,y-k) )/2hk
                
    return Jud
#retrieve Jud
matJud = Jud(1,5,1,5,ep)


workbook = xlsxwriter.Workbook('DataForBandB/Jud.xlsx')
 
#Add workbook
worksheet = workbook.add_worksheet()
 

row = 0
col = 0
 
# Iterate over the data and write it out row by row.
for u1, u2 in (matJud):
    worksheet.write(row, col, u1)
    worksheet.write(row, col + 1, u2)
    row += 1
 
workbook.close()
# Close the workbook

