
import numpy as np 
from sys import path
path.append(r"C:/Users/Bruker/Documents/CASADIPython/casadi-windows-py38-v3.5.5-64bit")
from casadi import *
import casadi as ca
from tabulate import tabulate
from texttable import Texttable
import latextable
from decimal import Decimal
import xlsxwriter


ep = 1e-8 #perturbation variable
import FiniteDiffJuu


#Use finite finite difference for multivariable to obtain how the cost function changes with valve change
def Juu(valve1, valve2, eps):
    Juu = np.zeros((2,2))
    nom, deltanom = FiniteDiffJuu.OptimizerSameu(valve2,0)
    for i in range(2):
        for j in range(2):
            if i == j and i == 0:
                f1, delta1 = FiniteDiffJuu.OptimizerSameu(valve1,eps)
                f2, delta2 = FiniteDiffJuu.OptimizerSameu(valve1,-eps)
                Juu[i][j] = (f1 - 2*nom + f2)/(delta1**2)
            if i == j and i == 1:
                f3, delta3 = FiniteDiffJuu.OptimizerSameu(valve2,eps)
                f4, delta4 = FiniteDiffJuu.OptimizerSameu(valve2,-eps)
                Juu[i][j] = (f3 - 2*nom + f4)/(delta3**2)
            if i != j:
                f5, h1, k1 =  FiniteDiffJuu.OptimizerDiffu(valve1,valve2, eps,eps)
                f6, h,k =  FiniteDiffJuu.OptimizerDiffu(valve1,valve2, eps,0)
                f7, h, k =  FiniteDiffJuu.OptimizerDiffu(valve1,valve2, 0,eps)
                f8, h, k =  FiniteDiffJuu.OptimizerDiffu(valve1,valve2, -eps,0)
                f9, h, k =  FiniteDiffJuu.OptimizerDiffu(valve1,valve2, 0,-eps)
                f10, h, k =  FiniteDiffJuu.OptimizerDiffu(valve1,valve2, -eps,-eps)
                Juu[i][j] = (f5 - f6 - f7 + 2*nom - f8 - f9 + f10)/(2*h1*k1)
            ###
            #if the same manipulated variable is looked at(e.g u1 and u1)
            # f''(x) = ( f(x+h) -2f(x) +f(x-h) )/h**2 (Second-order central)

            #if different manipulated variables are looked at e.g u2 and u1 
            #f''(x,y) = ( f(x+h,y+k) - f(x+h,y) - f(x,y+k) + 2f(x,y) - f(x-h,y) - f(x,y-k) 
            #+ f(x-h,y-k) )/2hk
            
    return Juu

#Retrieve Juu
matJuu = Juu(1,5,ep)
workbook = xlsxwriter.Workbook('DataForBandB/Juu.xlsx')
 
#Add workbook
worksheet = workbook.add_worksheet()
 
# Use the worksheet object to write
# data via the write() method.

row = 0
col = 0
 
# Iterate over the data and write it out row by row.
for u1, u2 in (matJuu):
    worksheet.write(row, col, u1)
    worksheet.write(row, col + 1, u2)
    row += 1
 
workbook.close()
# Close the file with close()