#Main file
#Coding based on and inspired by model made by Risvan Dirza(NTNU).
#Integrates the system of equations with the use of the CasADI framework IDAS integrator.
#Optimize the system of equations with the use of the CasADI framework IPOPT nlp solver.


import numpy as np
from sys import path
path.append(r"C:/Users/Bruker/Documents/CASADIPython/casadi-windows-py38-v3.5.5-64bit")
from casadi import *
import casadi as ca
from tabulate import tabulate
from texttable import Texttable
import latextable
from decimal import Decimal

# Call the parameters
import ParameterSOCN

#par now represents the dictionary defined in parameter function
par = ParameterSOCN.Params_6wells()




import pandas as pd
#Retrieve initial guesses for the differential states(x0), algebraic states(z0) and
#controlled variables(u0). Data listed in excel, comma separated files.
x0 = pd.read_csv('DatafolderSOCProdGasLimitWhN5/x06Sep.csv',header=None).values.reshape(-1)
z0 = pd.read_csv('DatafolderSOCProdGasLimitWhN5/z06Sep.csv',header=None).values.reshape(-1)
u0 = pd.read_csv('DatafolderSOCProdGasLimitWhN5/u06Sep.csv',header=None).values.reshape(-1)

#Retrieve the lower and upper bounds for the differential states(x), algebraic states(z) and
#controlled variables(u). Data listed in excel, comma separated files.
lbx = pd.read_csv('DatafolderSOCProdGasLimitWhN5/lbx6Sep.csv',header=None).values.reshape(-1)
lbz = pd.read_csv('DatafolderSOCProdGasLimitWhN5/lbz6Sep.csv',header=None).values.reshape(-1)
lbu = pd.read_csv('DatafolderSOCProdGasLimitWhN5/lbu6Sep.csv',header=None).values.reshape(-1)
ubx = pd.read_csv('DatafolderSOCProdGasLimitWhN5/ubx6Sep.csv',header=None).values.reshape(-1)
ubz = pd.read_csv('DatafolderSOCProdGasLimitWhN5/ubz6Sep.csv',header=None).values.reshape(-1)
ubu = pd.read_csv('DatafolderSOCProdGasLimitWhN5/ubu6Sep.csv',header=None).values.reshape(-1)



x0O = x0
z0O = z0
u0O = u0

#Define the parameter intial values(constant, if not manually changed)
p0 = ca.vertcat(par['GOR'],par['wmax_gl'],par['wmax_pg'],par['Powmax_glcom'],par['p_go'],par['p_oo'],par['omega1'],par['omega2'],par['omega3']) 
p00 = ca.vertcat(par['GOR'],par['wmax_gl'],par['wmax_pg'],par['Powmax_glcom'],par['p_go'],par['p_oo'],par['omega1'],par['omega2'],par['omega3']) 
#Call the simulator
import SimulatorSOCN

#Retrieve return variables of the integrator function
F,x_var, z_var, u_var, p_var, alg, dif, L, g_var =  SimulatorSOCN.CentralizedSimulator_F(par)

###For plotting of integration results ####
#t_span = np.arange(10000)
#x-values containers

m_ga1plot = []
m_ga2plot = []
m_ga3plot = []
m_ga4plot = []
m_ga5plot = []
m_ga6plot = []
m_gt1plot = []
m_gt2plot = []
m_gt3plot = []
m_gt4plot = []
m_gt5plot = []
m_gt6plot = []
m_ot1plot = []
m_ot2plot = []
m_ot3plot = []
m_ot4plot = []
m_ot5plot = []
m_ot6plot = []
m_grplot = []
m_orplot = []
p_gsplot = []
h_lsplot = []
p_s1plot = []
p_d1plot = []
w_c1plot = []
p_s2plot = []
p_d2plot = []
w_c2plot = []
p_s3plot = []
p_d3plot = []
w_c3plot = []
m_glplot = []
#u-value containers
u_gl1plot = []
u_gl2plot = []
u_gl3plot = []
u_gl4plot = []
u_gl5plot = []
u_gl6plot = []
z_ovplot = []
u_1plot = []
u_2plot = []
u_3plot = []
u_4plot = []
u_rec1plot = []
u_rec2plot = []
u_rec3plot = []
u_pc1plot = []
u_pc2plot = []
u_pc3plot = []
u_pc4plot = []
u_pc5plot = []
u_pc6plot = []
#z-calue containers
p_ai1plot = []
p_ai2plot = []
p_ai3plot = []
p_ai4plot = []
p_ai5plot = []
p_ai6plot = []
p_wh1plot = []
p_wh2plot = []
p_wh3plot = []
p_wh4plot = []
p_wh5plot = []
p_wh6plot = []
p_wi1plot = []
p_wi2plot = []
p_wi3plot = []
p_wi4plot = []
p_wi5plot = []
p_wi6plot = []
p_bh1plot = []
p_bh2plot = []
p_bh3plot = []
p_bh4plot = []
p_bh5plot = []
p_bh6plot = []
rho_ai1plot = []
rho_ai2plot = []
rho_ai3plot = []
rho_ai4plot = []
rho_ai5plot = []
rho_ai6plot = []
rho_m1plot = []
rho_m2plot = []
rho_m3plot = []
rho_m4plot = []
rho_m5plot = []
rho_m6plot = []
w_iv1plot = []
w_iv2plot = []
w_iv3plot = []
w_iv4plot = []
w_iv5plot = []
w_iv6plot = []
w_pc1plot = []
w_pc2plot = []
w_pc3plot = []
w_pc4plot = []
w_pc5plot = []
w_pc6plot = []
w_pg1plot = []
w_pg2plot = []
w_pg3plot = []
w_pg4plot = []
w_pg5plot = []
w_pg6plot = []
w_po1plot = []
w_po2plot = []
w_po3plot = []
w_po4plot = []
w_po5plot = []
w_po6plot = []
w_ro1plot = []
w_ro2plot = []
w_ro3plot = []
w_ro4plot = []
w_ro5plot = []
w_ro6plot = []
w_rg1plot = []
w_rg2plot = []
w_rg3plot = []
w_rg4plot = []
w_rg5plot = []
w_rg6plot = []
p_rhplot = []
rho_rplot = []
p_mplot = []
w_prplot = []
w_toplot = []
w_tgplot = []
w_osplot = []
w_gsplot = []
rho_gsplot = []
p_osplot = []
v_osplot = []
v_gsplot = []
w_in1plot = []
w_out1plot = []
rho_in1plot = []
rho_d1plot = []
Phi1plot = []
Pow1plot = []
y_p1plot = []
n_p1plot = []
Phi_max1plot = []
gamma_2_dummy1plot = []
w_rec1plot = []
w_in2plot = []
w_out2plot = []
rho_in2plot = []
rho_d2plot = []
Phi2plot = []
Pow2plot = []
y_p2plot = []
n_p2plot = []
Phi_max2plot = []
gamma_2_dummy2plot = []
w_rec2plot = []
w_in3plot = []
w_out3plot = []
rho_in3plot = []
rho_d3plot = []
Phi3plot = []
Pow3plot = []
y_p3plot = []
n_p3plot = []
Phi_max3plot = []
gamma_2_dummy3plot = []
w_rec3plot = []
w_gl1plot = []
w_gl2plot = []
w_gl3plot = []
w_gl4plot = []
w_gl5plot = []
w_gl6plot = []
p_outplot = []
rho_outplot = []
CostVsOpening = []
C1 = []
C2 = []
C3 = []
C4 = []
C5 = []
C6 = []
C7 = []
C8 = []
C9 = []
C10 = []
C11 = []
C12 = []
C13 = []
C14 = []
C15 = []
C16 = []
C17 = []
C18 = []
C19 = []
C20 = []
C21 = []
C22 = []
C23 = []
C24 = []
C25 = []
C26 = []

#Exact local method 2 MV/2 dist
B11 = []
B12 = []
B21 = []
B22 = []
B31 = []
B32 = []
B41 = []
B42 = []
B51 = []
B52 = []
B61 = []
B62 = []
B71 = []
B72 = []
B81 = []
B82 = []
B91 = []
B92 = []
B101 = []
B102 = []
B111 = []
B112 = []
B121 = []
B122 = []
B131 = []
B132 = []
B141 = []
B142 = []
B151 = []
B152 = []
B161 = []
B162 = []


#Define time span of simulation
t_span = np.arange(100000)

#Initialize initial values
uk = u0
xf = x0
zk = z0

#Make containers for storing integrator/control output
x_store =[]
z_store = []
u_store = []
p_store = []
error_store1 = [0]
error_store2 = [0,0]
error_store3 = [0,0]
error_store4 = [0]
error_store5 = [0]
error_store6 = [0]
error_store7 = [0]
error_store8 = [0]
error_storeA = [0]
error_storeB = [0]
error_storeC = [0]
error_storeD = [0]
error_store11 = [0]
error_store12 = [0]
error_store13 = [0]
error_store14 = [0]
error_storeC1 = [0]
error_storeC2 = [0]
error_storeC3 = [0]
error_storeC11 = [0]
error_storeC22 = [0]
error_storeC33 = [0]
B = []
u_1plot = []
u_2plot = []
u_3plot = []
u_4plot = []
u_5plot = []
u_6plot = []
u_7plot = []
u_8plot = []
u_11plot = []
u_12plot = []
u_13plot = []
u_14plot = []
lowestpoint = []
u_Aplot = []
u_Bplot = []
u_Cplot = []
u_Dplot = []
cplot = []
error_store = [0,0]
timer = 1000

################### Integrator ###################
Condition = 0
for k in t_span:
    #Change to simulate disturbance in GOR(Possible to implement disturbance in more variables)
    #p0[1]  += 0.0013
    #Simulate change in GOR for different wells
    #if k == 5000:
        #p0[1]   += 0.01
        #p0[1]   -= 0.02
        #p0[1]   += 0.0013*3
        #p0[5]   += 0.00135*2
        #p0[2] += 0.1
        #p0[3] += 0.1
        #p0[4] += 0.1
        #p0[5] -= 0.00135*2
   
        
    #Simulate change in valve opening for different wells
    #if k == 10000:
        #uk[0] -= 0.4
        #uk[1] += uk[1]*10**(-5)
        #uk[2] += uk[5]*10**(-5)
        #uk[3] += 0.1
        #uk[4] += 0.1
        #uk[5] += 0.1
        
        
    #Solving the initial value problem 
    inputs = ca.vertcat(uk, p0)
    Fk = F(x0 = xf, z0 = zk, p = inputs) 
    #Retrieving the differential states
    xf = (Fk['xf']).full()
    #Retrieving the algebraic states
    zk = (Fk['zf']).full()
    
    #zk[79] = 10
    #Append results
    x_store.append(xf)
    u_store.append(uk)
    z_store.append(zk)
    
    
    #Exact local method 2MV/2d from branch and bound F caluclated from linearized model
    
    
    #Annulus P and bottomhole P well 2 GLC2
    #PI controller, tuned with SIMC rules 
    h2 = 3583.10465771*zk[1] - 1449.41787407*zk[19]#-7.98501232*zk[1] - 64.82349538*zk[19]   
    h_sp2 =  1.64907832*10**(5)#-9.70655713*10**(3)#72.5945 #Nominal optimal wellhead pressure
    tau12 = 101#720
    tauC2 = 200#4000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(308.12053295 *tauC2)#Proportional gain 0.45315772
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Annulus P and bottomhole P well 2 GLC6
    #PI controller, tuned with SIMC rules 
    h3 = -146.18640435*zk[1] + 67.56021995*zk[19]#2.60067824*zk[1] + 16.08713207*zk[19]   
    h_sp3 =  -5.57177646*10**(3)#2.47171494*10**(3)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 185#424
    tauC3 = 200#4000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 1/(0.33032675*tauC3)#Proportional gain 0.04527007
    Ki3 = Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    
    
    #Annulus P2 and annulus P6 GLC2
    #PI controller, tuned with SIMC rules 
    h2 = 413.16600486*zk[1] + 326.50490982*zk[5]#22.88897358*zk[1] - 22.67672343*zk[5]   
    h_sp2 = 7.50573395*10**(4)#24.7206142#72.5945 #Nominal optimal wellhead pressure
    tau12 = 67
    tauC2 = 63#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(39.72975464 *tauC2)#Proportional gain 2.2514496
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Annulus P2 and annulus P6 GLC6
    #PI controller, tuned with SIMC rules 
    h3 = 305.9743484*zk[1] + 663.475804*zk[5]#-22.18074525*zk[1] + 24.49319288*zk[5]   
    h_sp3 = 9.83410265*10**(4)#2.31372351*10**(2)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 65
    tauC3 = 65#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 1/(63.61388852 *tauC3)#Proportional gain 2.39501819
    Ki3 = Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    #
    
    #Annulus P6 and DischargeP GLC2
    #PI controller, tuned with SIMC rules 
    h2 = -6976.59161527*xf[29] + 3401.78133543*zk[5]#-4.3656668*xf[29] - 26.84908555*zk[5]   
    h_sp2 = -7.65887664*10**(5)#-3.41748920*10**(3)#72.5945 #Nominal optimal wellhead pressure
    tau12 = 264
    tauC2 = 6000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = 500#ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(318.34137393 *tauC2)#Proportional gain 0.2417497
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Annulus P6 and DischargeP GLC6
    #PI controller, tuned with SIMC rules 
    h3 = -8339.24832552*xf[29] + 4481.00108404*zk[5]#10.22381382*xf[29] + 65.47016409*zk[5]   
    h_sp3 = -8.73421692*10**(5)#8.26624307*10**(3)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 163
    tauC3 = 6000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = 500#ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 1/(782.41556659*tauC3)#Proportional gain 5.99665696 
    Ki3 = Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    
    #Annulus P6 and DischargeP GLC2 and discharge pressure 6
    #PI controller, tuned with SIMC rules 
    h2 = -234922.1903769*xf[29] + 476847.10061302*zk[5]  - 181679.62737955*zk[23]#1290.90504975*xf[29] + 16765.46161926*zk[5] + 17129.3708444*zk[23]   
    h_sp2 = -1.40687276*10**(7)#4.26395815*10**(6)#72.5945 #Nominal optimal wellhead pressure
    tau12 = 274#744
    tauC2 = 4000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = 600#ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(9792.10072892*tauC2)#Proportional gain 7.27672269 
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Annulus P6 and DischargeP GLC6
    #PI controller, tuned with SIMC rules 
    h3 = -549333.90812753*xf[29] + 1128132.39347296*zk[5]  - 431189.32210637*zk[23]#-1676.90699719*xf[29] - 21807.04221199*zk[5]  - 22311.54379972*zk[23]   
    h_sp3 = -3.24457153*10**(7)#-5.55012462*10**(6)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 133#1454
    tauC3 = 2000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = 600#ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 1/(119828.95678892*tauC3)#Proportional gain 6.35087093
    Ki3 = Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    
    #Annulus P6 and DischargeP GLC2 and discharge pressure 6, annulus pressure 2
    #PI controller, tuned with SIMC rules 
    h2 = -805763.43006082*xf[29] + 131567.44007523*zk[5] +  291161.30688082*zk[23] +  427066.88982393*zk[1]#61119.14498099*xf[29] + 147027.68286197*zk[5] - 58183.45153308*zk[23] + 201082.69102819*zk[1]   
    h_sp2 = -3.15021186*10**(7)#3.70454342*10**(7)#72.5945 #Nominal optimal wellhead pressure
    tau12 = 169#52#52#120#28 #28
    tauC2 = 2000#3000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control
    theta2 = 0
    tauI2 = ca.fmin(tau12, 4*(tauC2 + theta2)) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 =  1/((75093.770713) *(tauC2 + theta2))#Proportional gain 17809.50303836
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Ki2*error2 + Kp2*error2 -  Kp2*error_store2[-1] )))) #Kp2*error2 - Kp2*error_store2[-1]
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    

    #Annulus P6 and DischargeP GLC6
    #PI controller, tuned with SIMC rules 
    h3 = -691151.33978905*xf[29] + 1042352.54566528*zk[5]  - 313718.6801493*zk[23] +  106098.72807374*zk[1]#62702.16245358*xf[29] + 118363.56280388*zk[5]  - 103353.02902385*zk[23] + 216378.02726489*zk[1]   
    h_sp3 = -3.67767947*10**(7)#2.97248713*10**(7)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 137#120 #120
    tauC3 = 1500#6000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 1/(120198.22672229*tauC3)#Proportional gain 5746.51735918
    Ki3 = Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    
    # discharge pressure, annulus pressure 2 GLC2
    #PI controller, tuned with SIMC rules 
    h2 = -2704.12302706*xf[29] +  327.18670482*zk[1]#10.56433836*xf[29] + 64.592046*zk[1]  
    h_sp2 =  -3.97329886*10**(5)#8.24045229*10**(3)#72.5945 #Nominal optimal wellhead pressure
    tau12 = 226#48 #28
    tauC2 = 226#2000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = 100#ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(152.50011205*tauC2)#Proportional gain 5.88649612
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Annulus P6 and DischargeP GLC6
    #PI controller, tuned with SIMC rules 
    h3 =  -2675.80879344*xf[29] + 68.22602697*zk[1]#-4.68023771*xf[29] - 27.54634754*zk[1]   
    h_sp3 = -4.19115433*10**(5)#77569*10**(3)#-3.54212505*10**(3)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 258#201 #120
    tauC3 = 258#2000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 1/(124.23138298 *tauC3)#Proportional gain 0.26182904
    Ki3 = Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    
    # discharge pressure, annulus pressure 2 GLC2
    #PI controller, tuned with SIMC rules 
    h2 = -41674.87829334*xf[29] - 52288.11647798*zk[1] + 23376.24685595*zk[19]#-2855.6340659*xf[29] - 19423.56983834*zk[1] - 16311.40372815*zk[19]  
    h_sp2 = -8.73664507*10**(6)#-4.66529004*10**(6)#72.5945 #Nominal optimal wellhead pressure
    tau12 = 10#1553#1553#78#1540#28
    tauC2 = 1553#5000#78#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 0.01*1/(20.70448516  *tauC2)#Proportional gain 3.90348885
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Annulus P6 and DischargeP GLC6
    #PI controller, tuned with SIMC rules 
    h3 =  -403800.65877812*xf[29] - 541499.5586333*zk[1]  + 240611.02868619*zk[19]#-6405.52726445*xf[29] - 43548.86813336*zk[1]  - 36426.92700546*zk[19]   
    h_sp3 =  -8.62554440*10**(7)#-1.04405564*10**(7)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 251#78 #120
    tauC3 = 5000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 100*1/(20122.01897968  *tauC3)#Proportional gain 366.28016462
    Ki3 = Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    
    # discharge pressure, annulus pressure 2 GLC2
    #PI controller, tuned with SIMC rules 
    h2 = -686015.79742427*xf[29] - 613181.02538563*zk[11] - 334371.87860306*zk[23] + 825709.36229966*zk[1]#-3716.69625337*xf[29] - 4798.98978458*zk[11] - 15641.39990574*zk[23] - 20136.44541368*zk[1]  
    h_sp2 = -1.20961591*10**(8)#-5.17761673*10**(6)#72.5945 #Nominal optimal wellhead pressure
    tau12 = 120#152#700#500#28
    tauC2 = 120#1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 0.1*1/(107137.28766212 *tauC2)#Proportional gain
    Ki2 = 10*Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Annulus P6 and DischargeP GLC6
    #PI controller, tuned with SIMC rules 
    h3 =  -659260.97418188*xf[29] - 243106.42626252*zk[11]  + 98775.47820129*zk[23] - 193401.98141469*zk[1]#10994.18774889*xf[29] + 96974.47619766*zk[11]  - 49965.87429334*zk[23] - 29143.59981315*zk[1]   
    h_sp3 =  -1.30643789*10**(8)#-2.54303615*10**(5)#72.5945 #Nominal optimal wellhead pressure
    tau13 = 221#500#502 #120
    tauC3 = 221#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI3 = ca.fmin(tau13, 4*tauC3) #Integral time, corresponding to SIMC rules for integration processes.
    Kp3 = 0.1*1/(30081.59183107 *tauC3)#Proportional gain
    Ki3 = 10*Kp3/tauI3 #Integral gain
    error3 = (h_sp3 - h3) #Difference between setpoint and measured   value
    #Calculate new controller output
    u3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][5] + (Kp3*error3 + Ki3*error3 - Kp3*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[5] = u3
    #Store all errors, to be used for previous errors
    error_store3.append(error3) 
    u_5plot.append(u3)
    
    
    ###############Implementation Exact local method positive##########################
    #BHP&PDIsch3
    #PI controller, tuned with SIMC rules 
    h2 = -539914.34688897*zk[19] - 2784.25256079*xf[29]#-446413.25092053*zk[19] + 19345.66174978*xf[29]   
    h_sp2 = -7.45362992*10**(7)#-58181520.23667923#72.5945 #Nominal optimal wellhead pressure
    tau12 = 431#645
    tauC2 = 2000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(7359.86887271 *tauC2)#Proportional gain 3664.2726547185534
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
    #BHP&Prod oil w2
    #PI controller, tuned with SIMC rules 
    h2 = -9.20434088*10**(2)*zk[19] + 0.491188339*zk[55]#-45.41318981*zk[19] - 0.08392059*zk[55]   
    h_sp2 = -1.26305988*10**(5)#-6233.1416364#72.5945 #Nominal optimal wellhead pressure
    tau12 = 434#624
    tauC2 = 2000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(12.33380599*tauC2)#Proportional gain 0.42254083285255406 
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
    #BHP&Prod gas w2
    #PI controller, tuned with SIMC rules 
    h2 = -42892.00474827*zk[19] + 22740.06185649*zk[49]#-2193.44492237*zk[19] - 3680.37324392*zk[49]   
    h_sp2 = -5.83284406*10**(6)#-309629.99426986#72.5945 #Nominal optimal wellhead pressure
    tau12 = 404#774
    tauC2 = 2000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(713.05330544*tauC2)#Proportional gain 8.377426299741053
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
    #BHP&tot gaslift
    #PI controller, tuned with SIMC rules 
    h2 = -293089.71870215*zk[19] + 21259.28465932*zk[107]#-19877.79126375*zk[19] - 9122.48640609*zk[107]   
    h_sp2 = -4.01290192*10**(7)#-2767317.74641531#72.5945 #Nominal optimal wellhead pressure
    tau12 = 432#634
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(3975.79288856 *tauC2)#Proportional gain 173.0044692063084 
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
    #Prod oil w2&Tot gaslift
    #PI controller, tuned with SIMC rules 
    h2 = 286.77917524*zk[55] + 15.07388955*zk[107]#257.76699191*zk[55] - 81.78981924*zk[107]   
    h_sp2 = 3.63226099*10**(3)#2852.31828537#72.5945 #Nominal optimal wellhead pressure
    tau12 = 110#211
    tauC2 = 500#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/( 10.69748668 *tauC2)#Proportional gain 4.721775281990528
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    #Prod gas w2&Tot gaslift
    #PI controller, tuned with SIMC rules 
    h2 = 2900.46415236*zk[49] - 388.45472794*zk[107]#2804.15788752*zk[49] - 750.21433487*zk[107]   
    h_sp2 =  5.11373807*10**(3)#3322.98685992#72.5945 #Nominal optimal wellhead pressure
    tau12 = 202#337
    tauC2 = 500#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(23.21338918*tauC2)#Proportional gain 12.736480716320484
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
     
    
    ###############Implementation Exact local method negative##########################
    #BHP&Pwh2
    #PI controller, tuned with SIMC rules 
    h2 = -5.34574111*10**(5)*zk[19] - 1.41642159*zk[7]#-483783.15402796*zk[19] - 9043.21957475*zk[1]   
    h_sp2 = -7.33602582*10**(7)#-67308259.10694613#72.5945 #Nominal optimal wellhead pressure
    tau12 = 434#645
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(7160.60340766*tauC2)#Proportional gain 3664.2726547185534
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    

    
    #BHP&Prod oil w2
    #PI controller, tuned with SIMC rules 
    h2 = -4.32905553*10**(5)*zk[19] + 2.30539895*10**(2)*zk[55]#-6.26485343*10**(4)*zk[19] + 26.0408009*zk[55]   
    h_sp2 = -5.94051978*10**(7)#-8596997.59926734#72.5945 #Nominal optimal wellhead pressure
    tau12 = 434#624
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(5800.92483758*tauC2)#Proportional gain 0.42254083285255406
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
    #BHP&Prod gas w2
    #PI controller, tuned with SIMC rules 
    h2 = -466615.86146777*zk[19] + 17771.12021649*zk[49]#-62520.82233189*zk[19] + 613.91453191*zk[49]   
    h_sp2 = -6.39925358*10**(7)#-8578357.35508944#72.5945 #Nominal optimal wellhead pressure
    tau12 = 432#774
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(6349.30100954*tauC2)#Proportional gain 8.377426299741053
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
    #BHP&tot gaslift
    #PI controller, tuned with SIMC rules 
    h2 = -526464.96151215 *zk[19] + 5189.13501704*zk[107]#-125435.8109666*zk[19] - 12587.91389531*zk[107]   
    h_sp2 = -7.22248665*10**(7)#-17268144.34149321#72.5945 #Nominal optimal wellhead pressure
    tau12 = 434#634
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(7059.68830538 *tauC2)#Proportional gain #173.0044692063084*20
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    
    #Prod oil w2&Tot gaslift
    #PI controller, tuned with SIMC rules 
    h2 = 284.98125313*zk[55] + 26.83981752*zk[107]#259.40899698*zk[55] + 122.2241566*zk[107]   
    h_sp2 = 3.66080317*10**(3)#3755.40804699#72.5945 #Nominal optimal wellhead pressure
    tau12 = 110#211
    tauC2 = 400#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(10.69984226 *tauC2)#Proportional gain 4.721775281990528
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    #Prod gas w2&Tot gaslift
    #PI controller, tuned with SIMC rules 
    h2 = 3016.84474179*zk[49] - 270.09782426*zk[107]#3051.23091538*zk[49] + 57.97844937*zk[107]   
    h_sp2 = 5.89843246*10**(3)#7398.40393725#72.5945 #Nominal optimal wellhead pressure
    tau12 = 200#337
    tauC2 = 500#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(24.81747272 *tauC2)#Proportional gain 12.736480716320484
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    ###############################################################################################
    
    
    

    #####################Single controlled variable SOC################################
    #Wellhead pressure case 7#(POSITIVE GAIN WITH Prod gas constraint)
    #PI controller, tuned with SIMC rules 
    h2 = z_store[k][7]   
    h_sp2 = 80.6189#72.5865#72.5945 #Nominal optimal wellhead pressure
    tau12 = 262
    tauC2 = 1500#400#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.012908143129770892*tauC2)#Proportional gain
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    hD = u_store[k][1]   
    h_spD = 0.64172 #   
    tauCD = 1200#1600#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] - (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
    
    
    #Bottomhole pressure#(POSITIVE GAIN WITH Prod gas constraint)
    #PI controller, tuned with SIMC rules 
    h2 = z_store[k][19]   
    h_sp2 = 137.231#123.725 #Nominal optimal bottomhole pressure
    tau12 = 690
    tauC2 = 1900#1300 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.01339127782608702*tauC2)#Proportional gain
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    #Annulus pressure#(POSITIVE GAIN WITH Prod gas constraint)
    #PI controller, tuned with SIMC rules 
    h2 = z_store[k][1]   
    h_sp2 = 101.536#87.8149 #Nominal optimal annulus pressure
    tau12 = 64
    tauC2 = 1300#64#1300 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.13092841875000039*tauC2)#Proportional gain
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #Separator pressure#(POSITIVE GAIN WITH Prod gas constraint)
    #PI controller, tuned with SIMC rules 
    h2 = x_store[k][20]   
    h_sp2 = 21.8954 #Nominal optimal Sep pressure
    tau12 = 550
    theta2 = 289
    tauC2 = 2000#1000#3000#1500#1300 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*(tauC2 + theta2)) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = (1/(0.00022573436363638227))*(1/(tauC2 + theta2))#Proportional gain
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    hD = u_store[k][1]   
    h_spD = 0.537969 #   
    tauCD = 3000#293#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] - (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
    
    
    hD = u_store[k][1]   
    h_spD = 0.537969 #   
    tauCD = 1000#1600#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] + (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
    
    #Manifold pressure#
    #PI controller, tuned with SIMC rules 
    h2 = z_store[k][74]   
    h_sp2 = 78.683 #Nominal optimal man pressure
    tau12 = 293
    tauC2 = 2500 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*(tauC2)) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = (1/(0.004487439590443815))*(1/(tauC2))#Proportional gain
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    hD = u_store[k][1]   
    h_spD = 0.537969 #   
    tauCD = 500#293#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] - (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
    
  
    #Discharge comp 3 pressure#Negative gain from prod gas.
    #PI controller, tuned with SIMC rules 
    h2 = x_store[k][29]   
    h_sp2 = 159.22 #Nominal optimal man pressure
    tau12 = 225
    tauC2 = 800#225#1300 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*(tauC2)) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = (1/(0.06490573644444389))*(1/(tauC2))#Proportional gain
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    hD = u_store[k][1]   
    h_spD = 0.537969 #   
    tauCD = 2000#1600#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] - (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
   
    
    
    
    
    #############Case 7 Nullspace Positive######################################
    #BHP&WHP
    #PI controller, tuned with SIMC rules 
    h2 = 0.99819296*zk[19] - 0.06009004*zk[7]#0.95155469*z_store[k][19] + 0.30747954*z_store[k][7]#0.99819296*zk[19] - 0.06009004*zk[7]#   
    h_sp2 =  132.1386341894136#155.37146395069#72.5945#132.13866341894136# #Nominal optimal wellhead pressure
    tau12 =  621#668 #621
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = (1/(0.00967549 *tauC2))#Proportional gain − #0.00967549 0.007077228592814475
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[-1])))) #- 0.1*Kp2*(error2 - error_store2[k-1]))))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #BHP&Annulus P
    #PI controller, tuned with SIMC rules 
    h2 = 0.99918968*zk[19] - 0.04024904*zk[1]#0.97178607*z_store[k][19] + 0.23586401*z_store[k][1]   
    h_sp2 = 133.03309302#157.3078622915#72.5945 #Nominal optimal wellhead pressure
    tau12 = 591#814
    tauC2 = 1500#3000#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.01025999 *tauC2)#Proportional gain 0.01025999 #0.005105094594594611
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #BHP&Manifold P#With negative gain
    #PI controller, tuned with SIMC rules 
    h2 = 0.99797747*zk[19] - 0.06356854*zk[74]#0.93394895*z_store[k][19] + 0.35740644*z_store[k][74]   
    h_sp2 = 131.95168963#156.2885592759#72.5945 #Nominal optimal wellhead pressure
    tau12 = 620#641
    tauC2 = 2000#1500#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.00942779*tauC2)#Proportional gain #0.008088352730108911
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #BHP&Disch comp3
    #PI controller, tuned with SIMC rules 
    h2 = 0.9999867*zk[19] +  0.00515668*xf[29]#0.99906231*z_store[k][19] - 0.04329552*x_store[k][29]   
    h_sp2 = 138.05023113#130.2088071692100#72.5945 #Nominal optimal wellhead pressure
    tau12 = 621#645
    tauC2 = 1200#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.00946077 *tauC2)#Proportional gain 0.008200548527131894
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    hD = u_store[k][1]   
    h_spD = 0.419185 #   
    tauCD = 1600#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] - (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
    
    #############Case 7 Nullspace Negative######################################
    #BHP&WHP
    #PI controller, tuned with SIMC rules 
    h2 =  0.99992464*zk[19] - 0.01227675*zk[7]#0.26764386*z_store[k][19] + 0.96351791*z_store[k][7]   
    h_sp2 = 136.23092774#114.40678858615#72.5945 #Nominal optimal wellhead pressure
    tau12 =  621#85 
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.00941242 *tauC2)#Proportional gain 0.011343201176470408
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    
    #BHP&ANnnulus P
    #PI controller, tuned with SIMC rules 
    h2 = 0.99999641*zk[19] - 0.00267783*zk[1]#0.99982427*z_store[k][19] + 0.0187467*z_store[k][1]   
    h_sp2 = 136.9586203#139.1103493275#72.5945 #Nominal optimal wellhead pressure
    tau12 =  621#638 
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.0093887 *tauC2)#Proportional gain 0.06698454823529186
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #BHP&Sep pressure
    #PI controller, tuned with SIMC rules 
    h2 = 0.99371152*zk[19] +  0.11197063*xf[20]#0.87581411*z_store[k][19] - 0.48264858*x_store[k][20]   
    h_sp2 = 138.81967765#109.6210472557125#72.5945 #Nominal optimal wellhead pressure
    tau12 =  623#624 
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.0092726 *tauC2)#Proportional gain 0.06698454823529186
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #BHP&Man pressure
    #PI controller, tuned with SIMC rules 
    h2 = 0.9999131*zk[19]  - 0.01318273*zk[74]#0.03331483*z_store[k][19] - 0.99944491*z_store[k][74]   
    h_sp2 = 136.18182529#-74.067496417#72.5945 #Nominal optimal wellhead pressure
    tau12 =  622#294 
    tauC2 = 2000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.00936008 *tauC2)#Proportional gain 0.002987406462584945
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    #BHP&Disch comp 3 pressure
    #PI controller, tuned with SIMC rules 
    h2 = 0.999999889*zk[19] - 4.70335652*10**(-4)*xf[29]#0.99994079*z_store[k][19] - 0.01088206*x_store[k][29]   
    h_sp2 = 137.15610524#135.4512098921#72.5945 #Nominal optimal wellhead pressure
    tau12 = 623 #629 
    tauC2 = 1000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*tauC2) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.00934041*tauC2)#Proportional gain 0.009034566454690212
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] - (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    hD = u_store[k][1]   
    h_spD = 0.537969 #   
    tauCD = 1600#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] - (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
    
    
    #BHP&Sep pressure
    #PI controller, tuned with SIMC rules 
    h2 = 5.55555562*10**(-6)*z_store[k][19] + x_store[k][20]   
    h_sp2 = 21.8915762#72.5945 #Nominal optimal wellhead pressure
    tau12 =  319
    theta1S = 189
    tauC2 = 4000#300#Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI2 = ca.fmin(tau12, 4*(tauC2 + theta1S)) #Integral time, corresponding to SIMC rules for integration processes.
    Kp2 = 1/(0.00014624952978058362 *(tauC2 + theta1S ))#Proportional gain
    Ki2 = Kp2/tauI2 #Integral gain
    error2 = (h_sp2 - h2) #Difference between setpoint and measured   value
    #Calculate new controller output
    u2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][1] + (Kp2*error2 + Ki2*error2 - Kp2*error_store2[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[1] = u2
    #Store all errors, to be used for previous errors
    error_store2.append(error2) 
    u_2plot.append(u2)
    
    hD = u_store[k][1]   
    h_spD = 0.537969 #   
    tauCD = 4000#2575 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tau1D = 500#65
    thetaD = 0
    #Opening = 0.291193 optimal nominal
    tauID = ca.fmin(tau1D, 4*(tauCD + thetaD)) #Integral time, corresponding to SIMC rules for integration processes.
    KpD = (1/(0.006462045398132644 ))*(1/(tauCD + thetaD)) #Proportional gain #0.0007929643656716369
    KiD = KpD/tauID #Integral gain
    errorD = (h_spD - hD) #Difference between setpoint and measured   value
    #Calculate new controller output
    uD= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] - (KpD*errorD + KiD*errorD - KpD*error_store3[-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[2] = uD
    #Store all errors, to be used for previous errors
    error_store3.append(errorD) 
    u_Dplot.append(uD)
    
    
    
    #################################################################
    ##################Surge Control##################################
    
    Scon = 3.25895 
    ###############Conmpressor 1###################################################
    if x_store[k][24] < Scon:#Scon:#3.79601:
        #PI controller, tuned with SIMC rules 
        hC1 = x_store[k][24]   
        h_spC1  = Scon#72.5945 #Nominal optimal wellhead pressure
        tau1C1  = 1
        tauCC1  = 10#100#Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauIC1  = ca.fmin(tau1C1 , 4*tauCC1 ) #Integral time, corresponding to SIMC rules for integration processes.
        KpC1  = 1/(0.3114571*tauCC1 )#1/(0.012908143129770892*tauC2)#Proportional gain
        KiC1  = KpC1 /tauIC1  #Integral gain
        errorC1  = (h_spC1  - hC1) #Difference between setpoint and measured   value
        #Calculate new controller output
        uC1  = ca.fmax(0, ca.fmin(1, (u_store[k-1][17] + (KpC1 *errorC1 + KiC1*errorC1 - KpC1*error_storeC1[-1] )))) 
        #Update the controller output for z_ov(oil valve separator)
        uk[17] = uC1 
        #Store all errors, to be used for previous errors
        error_storeC1.append(errorC1) 
        #u_2plot.append(u6)
    
    if x_store[k][24] > Scon and u_store[k-1][17] >= 0:
        #PI controller, tuned with SIMC rules 
        hC1 = x_store[k][24]   
        h_spC1  = Scon#72.5945 #Nominal optimal wellhead pressure
        tau1C1  = 10
        tauCC1  = 10#100#Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauIC1  = ca.fmin(tau1C1 , 4*tauCC1 ) #Integral time, corresponding to SIMC rules for integration processes.
        KpC1  = 1/(0.3114571*tauCC1 )#1/(0.012908143129770892*tauC2)#Proportional gain
        KiC1  = KpC1 /tauIC1  #Integral gain
        errorC1  = (h_spC1  - hC1) #Difference between setpoint and measured   value
        #Calculate new controller output
        uC1  = ca.fmax(0, ca.fmin(1, (u_store[k-1][17] + (KpC1 *errorC1 + KiC1*errorC1 - KpC1*error_storeC11[-1] )))) #+ Ki6*error6 - Kp6*error_store6[-1] ))))
        #Update the controller output for z_ov(oil valve separator)
        uk[17] = uC1 
        #Store all errors, to be used for previous errors
        error_storeC11.append(errorC1) 
        #u_2plot.append(u6)
    ################################################################################
    ###############Conmpressor 2###################################################
   
    
    if x_store[k][27] < Scon:#3.79601:
        #PI controller, tuned with SIMC rules 
        hC2 = x_store[k][27]   
        h_spC2 = Scon#72.5945 #Nominal optimal wellhead pressure
        tau1C2 = 10
        tauCC2 = 10#200#Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauIC2 = ca.fmin(tau1C2, 4*tauCC2) #Integral time, corresponding to SIMC rules for integration processes.
        KpC2 = 1/(2*0.3114571*tauCC2)#1/(0.012908143129770892*tauC2)#Proportional gain
        KiC2 = KpC2/tauIC2 #Integral gain
        errorC2 = (h_spC2 - hC2) #Difference between setpoint and measured   value
        #Calculate new controller output
        uC2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][18] + (KpC2*errorC2 + KiC2*errorC2 - KpC2*error_storeC2[-1] ))))
        #Update the controller output for z_ov(oil valve separator)
        uk[18] = uC2
        #Store all errors, to be used for previous errors
        error_storeC2.append(errorC2) 
        #u_2plot.append(u6)
    
    if x_store[k][27] > Scon and u_store[k-1][18] >= 0:
        #PI controller, tuned with SIMC rules 
        hC2 = x_store[k][27]   
        h_spC2 = Scon#72.5945 #Nominal optimal wellhead pressure
        tau1C2 = 10
        tauCC2 = 10#200#Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauIC2 = ca.fmin(tau1C2, 4*tauCC2) #Integral time, corresponding to SIMC rules for integration processes.
        KpC2 = 1/(2*0.3114571*tauCC2)#1/(0.012908143129770892*tauC2)#Proportional gain
        KiC2 = KpC2/tauIC2 #Integral gain
        errorC2 = (h_spC2 - hC2) #Difference between setpoint and measured   value
        #Calculate new controller output
        uC2 = ca.fmax(0, ca.fmin(1, (u_store[k-1][18] + (KpC2*errorC2 + KiC2*errorC2 - KpC2*error_storeC22[-1] ))))
        #Update the controller output for z_ov(oil valve separator)
        uk[18] = uC2
        #Store all errors, to be used for previous errors
        error_storeC22.append(errorC2) 
        #u_2plot.append(u6)
        
        ################################################################################
        ###############Conmpressor 3###################################################
        
    if x_store[k][30] < Scon:
        #PI controller, tuned with SIMC rules 
        hC3 = x_store[k][30]   
        h_spC3 = Scon#72.5945 #Nominal optimal wellhead pressure
        tau1C3 = 10
        tauCC3 = 10#400#Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauIC3 = ca.fmin(tau1C3, 4*tauCC3) #Integral time, corresponding to SIMC rules for integration processes.
        KpC3 = 1/(3*0.3114571*tauCC3)#1/(0.012908143129770892*tauC2)#Proportional gain
        KiC3 = KpC3/tauIC3 #Integral gain
        errorC3 = (h_spC3 - hC3) #Difference between setpoint and measured   value
        #Calculate new controller output
        uC3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][19] + (KpC3*errorC3 + KiC3*errorC3 - KpC3*error_storeC3[-1] ))))
        #Update the controller output for z_ov(oil valve separator)
        uk[19] = uC3
        #Store all errors, to be used for previous errors
        error_storeC3.append(errorC3) 
        #u_2plot.append(u6)
    
    if x_store[k][30] > Scon and u_store[k-1][19] >= 0:
        #PI controller, tuned with SIMC rules 
        hC3 = x_store[k][30]   
        h_spC3 = Scon#72.5945 #Nominal optimal wellhead pressure
        tau1C3 = 10
        tauCC3 = 10#400#Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauIC3 = ca.fmin(tau1C3, 4*tauCC3) #Integral time, corresponding to SIMC rules for integration processes.
        KpC3 = 1/(3*0.3114571*tauCC3)#1/(0.012908143129770892*tauC2)#Proportional gain
        KiC3 = KpC3/tauIC3 #Integral gain
        errorC3 = (h_spC3 - hC3) #Difference between setpoint and measured   value
        #Calculate new controller output
        uC3 = ca.fmax(0, ca.fmin(1, (u_store[k-1][19] + (KpC3*errorC3 + KiC3*errorC3 - KpC3*error_storeC33[-1] ))))
        #Update the controller output for z_ov(oil valve separator)
        uk[19] = uC3
        #Store all errors, to be used for previous errors
        error_storeC33.append(errorC3) 
        #u_2plot.append(u6)
    ################################################################################
    
    
    
    
    
    
    
    
    
    
    
 
    #Prod gas control Split Range control with Batton strategy
    #################################################################
    #if z_store[k][79] > 10.0001:
    if Condition == 0:
        ###### Test with multiple controllers controlling active constraint ########################################################################
        #PI controller, tuned with SIMC rules(integration process) well 4
        h4 = z_store[k][79]   
        h_sp4 = 10.0000 #   
        tauC4 = 2000#2000#5000#5000#5000#1500#2000#1500#800#572 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tau14 = 572#2000#1000#572
        #theta4 = 272
        #Opening = 0.291193 optimal nominal
        tauI4 = ca.fmin(tau14, 4*(tauC4 + theta4)) #Integral time, corresponding to SIMC rules for integration processes.
        Kp4 = (1/(0.000630722569930093))*(1/(tauC4 + theta4)) #Proportional gain #0.0007929643656716369
        Ki4 = Kp4/tauI4 #Integral gain
        error4 = (h_sp4 - h4) #Difference between setpoint and measured   value
        #Calculate new controller output
        #tauD = 2
        u4 = ca.fmax(0, ca.fmin(1, (u_store[k-1][0] + (Kp4*error4 + Ki4*error4 - Kp4*error_store[-1] + Kp4*0*(error4 - 2*error_store[-1] + error_store[-2]) ))))
        #Update the controller output for z_ov(oil valve separator)
        uk[0] = u4
        #Store all errors, to be used for previous errors
        error_store.append(error4) 
        u_4plot.append(u4)  
    
        if u4 == 1 or u4 == 0:
            Condition = 1
    if Condition == 1:
        #PI controller, tuned with SIMC rules(integration process) well 4
        hA = z_store[k][79]   
        h_spA = 10.0000 #   
        tauCA = 2000#3000#5000#800#559#800#Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tau1A = 559
        #thetaA = 288
        #Opening = 0.291193 optimal nominal #0.0006445851520572363
        tauIA = ca.fmin(tau1A, 4*(tauCA + thetaA)) #Integral time, corresponding to SIMC rules for integration processes.
        KpA = (1/(0.0006445851520572363))*(1/(tauCA + thetaA)) #Proportional gain #0.0007929643656716369
        KiA = KpA/tauIA #Integral gain
        errorA = (h_spA - hA) #Difference between setpoint and measured   value
        #Calculate new controller output
        uA = ca.fmax(0, ca.fmin(1, (u_store[k-1][4] + (KpA*errorA + KiA*errorA - KpA*error_store[-1] + KpA*0*(errorA - 2*error_store[-1] + error_store[-2])))))#+
        #Update the controller output for z_ov(oil valve separator)
        uk[4] = uA
        #Store all errors, to be used for previous errors
        error_store.append(errorA) 
        u_Aplot.append(uA)
        if uA == 1 or uA == 0:
            Condition = 2
    if Condition == 2:
        #PI controller, tuned with SIMC rules(integration process) well 4
        hB = z_store[k][79]   
        h_spB = 10.0000 #   
        tauCB = 2000#572 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tau1B = 572
        #thetaB = 296
        #Opening = 0.291193 optimal nominal
        tauIB = ca.fmin(tau1B, 4*(tauCB + thetaB)) #Integral time, corresponding to SIMC rules for integration processes.
        KpB = (1/(0.00065996849848586))*(1/(tauCB + thetaB)) #Proportional gain #0.0007929643656716369
        KiB = KpB/tauIB #Integral gain
        errorB = (h_spB - hB) #Difference between setpoint and measured   value
        #Calculate new controller output
        uB= ca.fmax(0, ca.fmin(1, (u_store[k-1][2] + (KpB*errorB + KiB*errorB- KpB*error_store[-1] )))) 
        #Update the controller output for z_ov(oil valve separator)
        uk[2] = uB
        #Store all errors, to be used for previous errors
        error_store.append(errorB) 
        u_Bplot.append(uB)
        if uB == 1 or uB == 0:
            Condition == 3
    
    if Condition == 3:
         #PI controller, tuned with SIMC rules(integration process) well 4
        hC = z_store[k][79]   
        h_spC = 10.0000 #   
        tauCC = 2000#572 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tau1C = 572
        #thetaC = 500#296
        #Opening = 0.291193 optimal nominal
        tauIC = ca.fmin(tau1C, 4*(tauCC + thetaC)) #Integral time, corresponding to SIMC rules for integration processes.
        KpC = (1/(0.000673985738959532))*(1/(tauCC + thetaC)) #Proportional gain #0.0007929643656716369
        KiC = KpC/tauIC #Integral gain
        errorC = (h_spC - hC) #Difference between setpoint and measured   value
        #Calculate new controller output
        uC= ca.fmax(0, ca.fmin(1, (u_store[k-1][3] + (KpC*errorC + KiC*errorC- KpC*error_store[-1] )))) 
        #Update the controller output for z_ov(oil valve separator)
        uk[3] = uC
        #Store all errors, to be used for previous errors
        error_store.append(errorC) 
        u_Cplot.append(uC)
        if uC == 1 or uC == 0:
            Condition = -1
    
    if Condition == -1:
        uk[0] == 0
    
    #Min selector, with logic to open previous valves
    openings = [uk[0] - u_store[k-1][0] , uk[4] - u_store[k-1][4], uk[2] - u_store[k-1][2],uk[3] - u_store[k-1][3]] #Find the valve from the split range controller that is active
    relatedtoop = [0,4,2,3] #The position in u_gl
    diffvalve, activevalve = next(((num, idx) for idx, num in enumerate(openings) if num != 0), (0, Condition)) #Find change in active valve and it's related index
    opt_open = [0.64172, 0.60811, 0.545984, 0.367095] #Nominal openings
    difffromopt = opt_open[activevalve] - u_store[k][relatedtoop[activevalve]] #meaures difference from nominal opening
    if diffvalve > difffromopt: #Min selector looks at which of the inputs is the smalles
        uk[relatedtoop[activevalve]] = opt_open[activevalve]
        #Restart the valve openings when the constraint is not active
        if uk[relatedtoop[activevalve]] == opt_open[activevalve] and Condition != 0:
            Condition -= 1  
    
    
    ###############################################################################################################################
              
    
    ############### Constant Level control ########################################
    #PI controller, tuned with SIMC rules(integration process) level separator
    h8 = x_store[k][21]   
    h_sp8 = 1.64904#1.64915  #   
    tauC8 = 500#500#50 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI8 = 4*tauC8 #Integral time, corresponding to SIMC rules for integration processes.
    Kp8 = 1/(0.005*tauC8)#Proportional gain
    Ki8 = Kp8/tauI8 #Integral gain
    error8 = (h_sp8 - h8) #Difference between setpoint and measured   value
    #Calculate new controller output
    u8 = ca.fmax(0, ca.fmin(1, (u_store[k-1][6] - (Kp8*error8 + Ki8*error8 - Kp8*error_store8[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[6] = u8
    #Store all errors, to be used for previous errors
    error_store8.append(error8) 
    u_8plot.append(u8)
    
    
    ############### HH and LL level control ########################################
    #PI controller, tuned with SIMC rules(integration process) level separator
    if x_store[k][21] < 0.8:#1.484:
        h8 = x_store[k][21]   
        h_sp8 = 0.8#1.484#1.64904#1.64915  #   
        tauC8 = 100 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauI8 = 4*tauC8 #Integral time, corresponding to SIMC rules for integration processes.
        Kp8 = 1/(0.005*tauC8)#Proportional gain 0.00005
        Ki8 = Kp8/tauI8 #Integral gain
        error8 = (h_sp8 - h8) #Difference between setpoint and measured   value
        #Calculate new controller output
        u8 = ca.fmax(0, ca.fmin(1, (u_store[k-1][6] - (Kp8*error8 + Ki8*error8 - Kp8*error_store8[-1] )))) 
        #Update the controller output for z_ov(oil valve separator)
        uk[6] = u8
        #Store all errors, to be used for previous errors
        error_store8.append(error8) 
        u_8plot.append(u8)
    if x_store[k][21] > 2.5:
        h8 = x_store[k][21]   
        h_sp8 = 2.5#1.814#1.64904#1.64915  #   
        tauC8 = 100 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
        tauI8 = 4*tauC8 #Integral time, corresponding to SIMC rules for integration processes.
        Kp8 = 1/(0.005*tauC8)#Proportional gain 0.00005
        Ki8 = Kp8/tauI8 #Integral gain
        error8 = (h_sp8 - h8) #Difference between setpoint and measured   value
        #Calculate new controller output
        u8 = ca.fmax(0, ca.fmin(1, (u_store[k-1][6] - (Kp8*error8 + Ki8*error8 - Kp8*error_store8[-1] )))) 
        #Update the controller output for z_ov(oil valve separator)
        uk[6] = u8
        #Store all errors, to be used for previous errors
        error_store8.append(error8) 
        u_8plot.append(u8)
    
    
    ################################
    #appending the resulting x values from the integration
    ################################
    
    m_ga1plot.append(xf[0])
    m_ga2plot.append(xf[1])
    m_ga3plot.append(xf[2])
    m_ga4plot.append(xf[3])
    m_ga5plot.append(xf[4])
    m_ga6plot.append(xf[5])
    m_gt1plot.append(xf[6])
    m_gt2plot.append(xf[7])
    m_gt3plot.append(xf[8])
    m_gt4plot.append(xf[9])
    m_gt5plot.append(xf[10])
    m_gt6plot.append(xf[11])
    m_ot1plot.append(xf[12])
    m_ot2plot.append(xf[13])
    m_ot3plot.append(xf[14])
    m_ot4plot.append(xf[15])
    m_ot5plot.append(xf[16])
    m_ot6plot.append(xf[17])
    m_grplot.append(xf[18])
    m_orplot.append(xf[19])
    
    p_gsplot.append(xf[20])
    h_lsplot.append(xf[21])
    p_s1plot.append(xf[22])
    p_d1plot.append(xf[23])
    w_c1plot.append(xf[24])
    p_s2plot.append(xf[25])
    p_d2plot.append(xf[26])
    w_c2plot.append(xf[27])
    p_s3plot.append(xf[28])
    p_d3plot.append(xf[29])
    w_c3plot.append(xf[30])
    m_glplot.append(xf[31])

    ################################
    #appending u-values
    ################################
    u_gl1plot.append(uk[0])
    u_gl2plot.append(uk[1])
    u_gl3plot.append(uk[2])
    u_gl4plot.append(uk[3])
    u_gl5plot.append(uk[4])
    u_gl6plot.append(uk[5])
    z_ovplot.append(uk[6])
    u_1plot.append(uk[7]) 
    #u_2plot.append(uk[14])
    #u_3plot.append(uk[15])  
    #u_4plot.append(uk[16])
    u_rec1plot.append(uk[17]) 
    u_rec2plot.append(uk[18]) 
    u_rec3plot.append(uk[19]) 
    u_pc1plot.append(uk[8]) 
    u_pc2plot.append(uk[9]) 
    u_pc3plot.append(uk[10]) 
    u_pc4plot.append(uk[11]) 
    u_pc5plot.append(uk[12]) 
    u_pc6plot.append(uk[13]) 
    ###############################
    #appending z-values
    ###############################

    p_ai1plot.append(zk[0]) 
    p_ai2plot.append(zk[1]) 
    p_ai3plot.append(zk[2])  
    p_ai4plot.append(zk[3])  
    p_ai5plot.append(zk[4])  
    p_ai6plot.append(zk[5])  
    p_wh1plot.append(zk[6])  
    p_wh2plot.append(zk[7])  
    p_wh3plot.append(zk[8])  
    p_wh4plot.append(zk[9])  
    p_wh5plot.append(zk[10])  
    p_wh6plot.append(zk[11])  
    p_wi1plot.append(zk[12])  
    p_wi2plot.append(zk[13])  
    p_wi3plot.append(zk[14])  
    p_wi4plot.append(zk[15])  
    p_wi5plot.append(zk[16])  
    p_wi6plot.append(zk[17])  
    p_bh1plot.append(zk[18])  
    p_bh2plot.append(zk[19])  
    p_bh3plot.append(zk[20])  
    p_bh4plot.append(zk[21])  
    p_bh5plot.append(zk[22])  
    p_bh6plot.append(zk[23]) 
    
    rho_ai1plot.append(zk[24])  
    rho_ai2plot.append(zk[25])  
    rho_ai3plot.append(zk[26])  
    rho_ai4plot.append(zk[27])  
    rho_ai5plot.append(zk[28])  
    rho_ai6plot.append(zk[29])  
    rho_m1plot.append(zk[30])  
    rho_m2plot.append(zk[31])  
    rho_m3plot.append(zk[32])  
    rho_m4plot.append(zk[33])  
    rho_m5plot.append(zk[34])  
    rho_m6plot.append(zk[35])  
    w_iv1plot.append(zk[36])  
    w_iv2plot.append(zk[37])  
    w_iv3plot.append(zk[38])  
    w_iv4plot.append(zk[39])  
    w_iv5plot.append(zk[40])  
    w_iv6plot.append(zk[41])  
    w_pc1plot.append(zk[42])  
    w_pc2plot.append(zk[43])  
    w_pc3plot.append(zk[44])  
    w_pc4plot.append(zk[45])  
    w_pc5plot.append(zk[46])  
    w_pc6plot.append(zk[47])  
    w_pg1plot.append(zk[48])  
    w_pg2plot.append(zk[49])  
    w_pg3plot.append(zk[50])  
    w_pg4plot.append(zk[51])  
    w_pg5plot.append(zk[52])  
    w_pg6plot.append(zk[53])  
    w_po1plot.append(zk[54])  
    w_po2plot.append(zk[55])  
    w_po3plot.append(zk[56])  
    w_po4plot.append(zk[57])  
    w_po5plot.append(zk[58])  
    w_po6plot.append(zk[59])  
    w_ro1plot.append(zk[60])  
    w_ro2plot.append(zk[61])  
    w_ro3plot.append(zk[62])  
    w_ro4plot.append(zk[63])  
    w_ro5plot.append(zk[64])  
    w_ro6plot.append(zk[65])  
    w_rg1plot.append(zk[66])  
    w_rg2plot.append(zk[67])  
    w_rg3plot.append(zk[68])  
    w_rg4plot.append(zk[69])  
    w_rg5plot.append(zk[70])  
    w_rg6plot.append(zk[71])  
    p_rhplot.append(zk[72])  
    rho_rplot.append(zk[73])
    
    p_mplot.append(zk[74])  
    w_prplot.append(zk[75])  
    w_toplot.append(zk[76])  
    w_tgplot.append(zk[77])  
    w_osplot.append(zk[78])  
    w_gsplot.append(zk[79])  
    rho_gsplot.append(zk[80])  
    p_osplot.append(zk[81])  
    v_osplot.append(zk[82])  
    v_gsplot.append(zk[83])  
    w_in1plot.append(zk[84])  
    w_out1plot.append(zk[85])  
    rho_in1plot.append(zk[86])  
    rho_d1plot.append(zk[87])  
    Phi1plot.append(zk[88])  
    Pow1plot.append(zk[89])  
    y_p1plot.append(zk[90])  
    n_p1plot.append(zk[91])  
    Phi_max1plot.append(zk[92]) 
    gamma_2_dummy1plot.append(zk[93])  
    w_rec1plot.append(zk[94])  
    w_in2plot.append(zk[95])  
    w_out2plot.append(zk[96])  
    rho_in2plot.append(zk[97])  
    rho_d2plot.append(zk[98])  
    Phi2plot.append(zk[99])  
    Pow2plot.append(zk[100])  
    y_p2plot.append(zk[101])  
    n_p2plot.append(zk[102])  
    Phi_max2plot.append(zk[103])  
    gamma_2_dummy2plot.append(zk[104])  
    w_rec2plot.append(zk[105])  
    w_in3plot.append(zk[106])  
    w_out3plot.append(zk[107])  
    rho_in3plot.append(zk[108])  
    rho_d3plot.append(zk[109])  
    Phi3plot.append(zk[110])  
    Pow3plot.append(zk[111])  
    y_p3plot.append(zk[112])  
    n_p3plot.append(zk[113])  
    Phi_max3plot.append(zk[114])  
    gamma_2_dummy3plot.append(zk[115])  
    w_rec3plot.append(zk[116])  
    w_gl1plot.append(zk[117])  
    w_gl2plot.append(zk[118])  
    w_gl3plot.append(zk[119])  
    w_gl4plot.append(zk[120])  
    w_gl5plot.append(zk[121])  
    w_gl6plot.append(zk[122])  
    p_outplot.append(zk[123])  
    rho_outplot.append(zk[124])  
    ######
    
    B.append(-0.6*zk[78] + 0.03*(zk[89] + zk[100] + zk[111]))
    
    #Nullspace positive
    C1.append(0.95155469*zk[19] + 0.30747954*zk[7])
    C2.append(0.97178607*zk[19] + 0.23586401*zk[1])
    C3.append(0.93394895*zk[19] + 0.35740644*zk[74])
    C4.append(0.99906231*zk[19] - 0.04329552*xf[29])
    #Nullspace negative
    C5.append(0.26764386*zk[19] + 0.96351791*zk[7])
    C6.append(0.99982427*zk[19] + 0.0187467*zk[1])
    C7.append(0.87581411*zk[19] - 0.48264858*xf[20])
    C8.append(0.03331483*zk[19] - 0.99944491*zk[74])
    C9.append(0.99994079*zk[19] - 0.01088206*xf[29])
    
    #Nullspace positive New
    C1.append(0.99819296*zk[19] - 0.06009004*zk[7]) #132.1386341894136
    C2.append(0.99918968*zk[19] - 0.04024904*zk[1]) #133.03309302
    C3.append(0.99797747*zk[19] - 0.06356854*zk[74]) #c_ns = 131.95168963
    C4.append(0.9999867*zk[19] +  0.00515668*xf[29]) #c_ns = 138.05023113
    #Nullspace negative New
    C5.append( 0.99992464*zk[19] - 0.01227675*zk[7])  #c_ns = 136.23092774
    C6.append(0.99999641*zk[19] - 0.00267783*zk[1]) #c_ns = 136.9586203
    C7.append(0.99371152*zk[19] +  0.11197063*xf[20]) #c_ns = 138.81967765
    C8.append(0.9999131*zk[19]  - 0.01318273*zk[74]) #c_ns = 136.18182529
    C9.append(0.999999889*zk[19] - -4.70335652*10**(-4)*xf[29]) #c_ns = 137.15610524
    
    
    
    
    
    #Test multiple controllers
    C10.append(5.55555562*10**(-6)*zk[19] + 1*xf[20])
    C11.append(0.04200139*zk[7] + 0.99843881*zk[19] + 0.00643228*zk[1] + 0.00407959*zk[74] - 0.03602514*xf[29])#ugl2
    C12.append(-0.17305043*zk[7] + 0.00643228*zk[19] + 0.97349828*zk[1] - 0.01680838*zk[74] + 0.1484276*xf[29])#u1
    C13.append(-0.10975503*zk[7] +  0.00407959*zk[19] - 0.01680838*zk[1] + 0.9893395*zk[74] + 0.09413832*xf[29])#ugl3
    C14.append(0.96919972*zk[7] - 0.03602514*zk[19] + 0.1484276*zk[1] + 0.09413832*zk[74] + 0.16870481*xf[29])#ugl4
    
    #Positive Exact local method
    C15.append(-446413.25092053*zk[19] + 19345.66174978*xf[29])
    C16.append(-45.41318981*zk[19] - 0.08392059*zk[55]) 
    C17.append(-2193.44492237*zk[19] - 3680.37324392*zk[49]) 
    C18.append(-19877.79126375*zk[19] - 9122.48640609*zk[107]) 
    C19.append(257.76699191*zk[55] - 81.78981924*zk[107]) 
    C20.append(2804.15788752*zk[49] - 750.21433487*zk[107]) 
    
    #Negative Exact local method
    C21.append(-483783.15402796*zk[19] - 9043.21957475*zk[1])
    
    C22.append(-6.26485343*10**(4)*zk[19] + 26.0408009*zk[55]) 
    C23.append(-62520.82233189*zk[19] + 613.91453191*zk[49]) 
    C24.append(-125435.8109666*zk[19] - 12587.91389531*zk[107]) 
    C25.append(259.40899698*zk[55] + 122.2241566*zk[107]) 
    C26.append(3051.23091538*zk[49] + 57.97844937*zk[107]) 
    
    #Positive Exact local method new
    C15.append(-539914.34688897*zk[19] - 2784.25256079*xf[29])
    C16.append(-9.20434088*10**(2)*zk[19] + 0.491188339*zk[55]) 
    C17.append(-42892.00474827*zk[19] + 22740.06185649*zk[49]) 
    C18.append(-293089.71870215*zk[19] + 21259.28465932*zk[107]) 
    C19.append(286.77917524*zk[55] + 15.07388955*zk[107]) 
    C20.append(2900.46415236*zk[49] - 388.45472794*zk[107]) 
    
    #Negative Exact local method new
    C21.append(-5.34574111*10**(5)*zk[19] - 1.41642159*zk[7])
    
    C22.append(-4.32905553*10**(5)*zk[19] + 2.30539895*10**(2)*zk[55]) 
    C23.append(-466615.86146777*zk[19] + 17771.12021649*zk[49]) 
    C24.append(-526464.96151215 *zk[19] + 5189.13501704*zk[107]) 
    C25.append(284.98125313*zk[55] + 26.83981752*zk[107]) 
    C26.append(3016.84474179*zk[49] - 270.09782426*zk[107]) 
    
    
    
    
    
    #Exact local method 2MV/2 dist
    #Positive GOR
    B11.append(-7.98501232*zk[1] - 64.82349538*zk[19])
    B12.append(2.60067824*zk[1] + 16.08713207*zk[19])
    
    B21.append(22.88897358*zk[1] - 22.67672343*zk[5])
    B22.append(-22.18074525*zk[1] + 24.49319288*zk[5])
    
    B31.append(-4.3656668*xf[29] - 26.84908555*zk[5])
    B32.append(10.22381382*xf[29] + 65.47016409*zk[5])
    
    B41.append(1290.90504975*xf[29] + 16765.46161926*zk[5] + 17129.3708444*zk[23])
    B42.append(-1676.90699719*xf[29] - 21807.04221199*zk[5]  - 22311.54379972*zk[23])
    
    B51.append(61119.14498099*xf[29] + 147027.68286197*zk[5] - 58183.45153308*zk[23] + 201082.69102819*zk[1])
    B52.append(62702.16245358*xf[29] + 118363.56280388*zk[5]  - 103353.02902385*zk[23] + 216378.02726489*zk[1])
    
    B61.append(10.56433836*xf[29] + 64.592046*zk[1])
    B62.append(-4.68023771*xf[29] - 27.54634754*zk[1])
    
    B71.append(-2855.6340659*xf[29] - 19423.56983834*zk[1] - 16311.40372815*zk[19])
    B72.append(-6405.52726445*xf[29] - 43548.86813336*zk[1]  - 36426.92700546*zk[19])
    
    B81.append(-3716.69625337*xf[29] - 4798.98978458*zk[11] - 15641.39990574*zk[23] - 20136.44541368*zk[1])
    B82.append(10994.18774889*xf[29] + 96974.47619766*zk[11]  - 49965.87429334*zk[23] - 29143.59981315*zk[1])
    
    #Negative GOR
    B91.append(-8361.73566402*zk[1] - 447667.21081462*zk[19])
    B92.append(1732.29646306*zk[1] + 92410.72240929*zk[19])
    
    B101.append(27.44028606*zk[1] + 0.88681124*zk[5])
    B102.append(0.19466741*zk[1] + 56.00386487*zk[5])
    
    B111.append(-17.41643364*xf[29] - 12.97245266*zk[5])
    B112.append(-10.17879649*xf[29] + 47.6991263*zk[5])
    
    B121.append(-478.12873683*xf[29] + 2230.28224625*zk[5] + 96372.60899258*zk[23])
    B122.append(2147.79026662*xf[29] - 10459.67002223*zk[5]  - 451407.75988817*zk[23])
    
    B131.append(-25887.46368923*xf[29] - 17940.01178791*zk[5] + 96464.81364318*zk[23] - 43658.25180635*zk[1])
    B132.append(-173556.7739217*xf[29] - 149936.46976775*zk[5]  - 450770.1683109*zk[23] - 301895.11536725*zk[1])
    
    B141.append(-15.291117*xf[29] + 1.09866488*zk[1])
    B142.append(-169.14956472*xf[29] - 290.9096779*zk[1])
    
    B151.append(1771.19498418*xf[29] - 5980.18444265*zk[1] - 483434.7839778*zk[19])
    B152.append(-551.82431496*xf[29] + 990.31272722*zk[1]  + 103554.28183372*zk[19])
    
    B161.append(3101.32595098*xf[29] + 83580.47286321*zk[11] - 483442.38333034*zk[23] - 3881.96886745*zk[1])
    B162.append(9522.55485732*xf[29] + 633036.44230348*zk[11]  + 103496.72452484*zk[23] + 16882.14580032*zk[1])
    
    
    
    #Exact local method 2MV/2 dist new F = dy/du
    #Positive GOR
    B11.append(262.73305154*zk[1] - 5405.75910492*zk[19])
    B12.append(-49.55775679*zk[1] + 1024.08822321*zk[19])
    
    B21.append(21.3202415*zk[1] - 17.0239858*zk[5])
    B22.append(-16.24253356*zk[1] + 13.61745927*zk[5])
    
    B31.append(-2.73047731*xf[29] - 18.56622293*zk[5])
    B32.append(5.69386534*xf[29] + 39.39328154*zk[5])
    
    B41.append(-4776.52311651*xf[29] + 13848.85934925*zk[5] + 134604.1345925*zk[23])
    B42.append(14989.20015347*xf[29] - 43486.3050394*zk[5]  - 422482.0911806*zk[23])
    
    B51.append(44144.59427475*xf[29] + 186246.51824044*zk[5] +  127291.28221963*zk[23] +  197772.20401727*zk[1])
    B52.append(52545.97703735*xf[29] + 88863.50125175*zk[5]  - 428096.17318851*zk[23] + 151829.86277082*zk[1])
    
    B61.append(6.97905258*xf[29] + 59.01674559*zk[1])
    B62.append(-2.34535959*xf[29] - 19.47440931*zk[1])
    
    B71.append(-8217.86437896*xf[29] - 43636.39030824*zk[1] - 510211.17724758*zk[19])
    B72.append(1451.93134491*xf[29] + 7706.53437138*zk[1]  + 90213.05215366*zk[19])

    B81.append(-18668.46283178*xf[29] - 88207.07033211*zk[11] - 509535.79352571*zk[23] - 53203.53374925*zk[1])
    B82.append(42011.02824372*xf[29] + 342334.37720436*zk[11]  + 87591.86697055*zk[23] + 44836.91495394*zk[1])
    
    
    
    #Negative GOR
    B91.append(5.66780409*10**(2)*zk[1] - 1.29304852*10**(5)*zk[19])
    B92.append(-1.08955450*10**(2)*zk[1] + 92410.72240929*10**(4)*zk[19])
    B101.append(19.34328063*zk[1] - 12.68412868*zk[5])
    B102.append(-12.60618675*zk[1] +  28.29496047*zk[5])
    B111.append(-0.92565692*xf[29] + 1.59970784*zk[5])
    B112.append(-1.29256536*xf[29] + 20.86229131*zk[5])
    B121.append(1124.0888743*xf[29] + 13506.02748707*zk[5] + 84996.94427602*zk[23])
    B122.append(-5895.11552797*xf[29] - 70727.29636203*zk[5]  - 445289.30784748*zk[23])
    B131.append(-113289.79962532*xf[29] - 426206.37623219*zk[5] + 124911.1956689*zk[23] +  810049.2431397*zk[1])
    B132.append(13751.40257385*xf[29] +  4777.67783779*zk[5]  - 452143.16163039*zk[23] - 139097.16143212*zk[1])
    B141.append(-14.89941033*xf[29] + 91.88326244*zk[1])
    B142.append(-4.83431855*xf[29] - 25.85243427*zk[1])
    B151.append(-2.04592345*10**(3)*xf[29] + 1.31255197*10**(4)*zk[1] - 5.49032199*10**(5)*zk[19])
    B152.append(3.72185169*10**(2)*xf[29] - 2.39358468*10**(3)*zk[1]  +  1.01916981*10**(5)*zk[19])
    B161.append(-27598.25690498*xf[29] - 507211.84911125*zk[11] - 545266.45637924*zk[23] + 293076.88722314*zk[1])
    B162.append(18765.22060244*xf[29] + 365100.33533589*zk[11]  + 99206.33061025*zk[23] - 203907.68245748*zk[1])
    
    
    #Exact local method 2MV/2 dist new F = dy/du
    #Positive GOR
    B11.append(3583.10465771*zk[1] - 1449.41787407*zk[19])
    B12.append(-146.18640435*zk[1] + 67.56021995*zk[19])
    
    B21.append(413.16600486*zk[1] + 326.50490982*zk[5])
    B22.append(305.9743484*zk[1] + 663.475804*zk[5])
    
    B31.append(-6976.59161527*xf[29] + 3401.78133543*zk[5])
    B32.append(-8339.24832552*xf[29] + 4481.00108404*zk[5])
    
    B41.append(-234922.1903769*xf[29] + 476847.10061302*zk[5]  - 181679.62737955*zk[23])
    B42.append(-549333.90812753*xf[29] + 1128132.39347296*zk[5]  - 431189.32210637*zk[23])
    
    B51.append(-805763.43006082*xf[29] + 131567.44007523*zk[5] +  291161.30688082*zk[23] +  427066.88982393*zk[1])
    B52.append(-691151.33978905*xf[29] + 1042352.54566528*zk[5]  - 313718.6801493*zk[23] +  106098.72807374*zk[1])
    
    B61.append(-2704.12302706*xf[29] +  327.18670482*zk[1])
    B62.append(-2675.80879344*xf[29] + 68.22602697*zk[1])
    
    B71.append(-41674.87829334*xf[29] - 52288.11647798*zk[1] + 23376.24685595*zk[19])
    B72.append(-403800.65877812*xf[29] - 541499.5586333*zk[1]  + 240611.02868619*zk[19])

    B81.append(-686015.79742427*xf[29] - 613181.02538563*zk[11] - 334371.87860306*zk[23] + 825709.36229966*zk[1])
    B82.append(-659260.97418188*xf[29] - 243106.42626252*zk[11]  + 98775.47820129*zk[23] - 193401.98141469*zk[1])


print('Power 2:', Pow2plot[-1])
print(Power2)
print('Power 3:', Pow3plot[-1])
print(Power3)
print('Oil prod :', w_osplot[-1])
print(Oil)
print('Cost caluclated in the simulations',B[-1])
print('Recycle flow 1', w_rec1plot[-1])
print('Recycle flow 2', w_rec2plot[-1])
print('Recycle flow 3', w_rec3plot[-1])
print('Flow through compressor 1', w_c1plot[-1])
print('Flow through compressor 2', w_c2plot[-1])
print('Flow through compressor 3', w_c3plot[-1]) 

print('Separator pressure sec last: ', p_gsplot[-2])
print('Separator level last: ', h_lsplot[-1])
print('Separator level sec last: ', h_lsplot[-2])
print('Oil flow into separator: ', w_toplot[-2])
print('Oil out sep:', w_osplot[-1]) 





