
import numpy as np 
from sys import path
path.append(r"C:/Users/Bruker/Documents/CASADIPython/casadi-windows-py38-v3.5.5-64bit")
from casadi import *
import casadi as ca
from tabulate import tabulate
from texttable import Texttable
import latextable
from decimal import Decimal
import xlsxwriter

# Call the parameters
import ParameterSOCN

#par now represents the dictionary defined in parameter function
par = ParameterSOCN.Params_6wells()


#Define the parameter intial values(constant, if not manually changed)
p0 = ca.vertcat(par['GOR'],par['wmax_gl'],par['wmax_pg'],par['Powmax_glcom'],
                par['p_go'],par['p_oo'],par['omega1'],par['omega2'],par['omega3'])

#Define the disturbance matrix
def Wd():
    Wd = np.zeros((2,2))
    Wd[0][0] =  (p0[1]/100)*3
    Wd[1][1] = (p0[5]/100)*2
    return Wd

#retireve Wd
matWd = Wd()

workbook = xlsxwriter.Workbook('DataForBandB/Wd.xlsx')
 
#Add the workbook
worksheet = workbook.add_worksheet()
 
# Use the worksheet object to write
# data via the write() method.

row = 0
col = 0
 
# Iterate over the data and write it out row by row.
for d1, d2 in (matWd):
    worksheet.write(row, col, d1)
    worksheet.write(row, col + 1, d2)
    row += 1
 
workbook.close()